#define SAVE_SCREEN        // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "titre.h"
#include "TFPdraw.h"
char *pl0,*pl1;
static int best_score=0;
#include "draw.h"
#define ROWCOL(a,b) ((_rowread(~((short)1<<a)))&(1<<b))
#define HBG(a) (a+16)
#define VBG(a) (a+8)
#define CENTERED ((240-XStrLen(buffer,NORMAL))/2)

typedef struct{
unsigned char L,T,R,B;
}HOTSPOT;

short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
  int x=1,y=1,currperso=0,i=1,bkp,score=0;
  char buffer[50];
  HOTSPOT zones[8]={
  {HBG(33),VBG(0),HBG(64),VBG(23)},
  {HBG(83),VBG(0),HBG(114),VBG(23)},
  {HBG(133),VBG(0),HBG(164),VBG(24)},
  {HBG(53),VBG(25),HBG(84),VBG(48)},
  {HBG(110),VBG(25),HBG(141),VBG(48)},
  {HBG(25),VBG(53),HBG(56),VBG(75)},
  {HBG(83),VBG(53),HBG(114),VBG(75)},
  {HBG(138),VBG(53),HBG(169),VBG(76)}};
  
  INT_HANDLER autoint_bkp;
  autoint_bkp = GetIntVec (AUTO_INT_1);//sauvegarde de 'AutoInt 1'
  SetIntVec(AUTO_INT_1, DUMMY_HANDLER);//remplacement de 'AutoInt 1' par DUMMY_HANDLER
  GrayOn();
  BEGUSE_TFP();
  CONFIG_TFP("lapin689");
  pl0=malloc(3840);
  pl1=malloc(3840);
  memset(pl0,0,3840);
  memset(pl1,0,3840);
  draw_start();
  sprintf(buffer,"un jeu de la janjan2team");
	XStr(CENTERED,2,buffer,NORMAL,MODE_OR,pl1);
  XStr(CENTERED,2,buffer,NORMAL,MODE_OR,pl0);
  XStr(CENTERED+1,3,buffer,NORMAL,MODE_OR,pl0);
  sprintf(buffer,"eclate les gromfs avec ton sbam");
	XStr(CENTERED,94,buffer,NORMAL,MODE_OR,pl1);
  XStr(CENTERED,94,buffer,NORMAL,MODE_OR,pl0);
  XStr(CENTERED+1,95,buffer,NORMAL,MODE_OR,pl0);
  sprintf(buffer,"(C) midam achetez les bozalbums");
	XStr(CENTERED,114,buffer,NORMAL,MODE_OR,pl1);
  XStr(CENTERED,114,buffer,NORMAL,MODE_OR,pl0);
  XStr(CENTERED+1,115,buffer,NORMAL,MODE_OR,pl0);
  virtTOscr();
  while(!(ROWCOL(6,6)||ROWCOL(9,1)));
  while((ROWCOL(6,6)||ROWCOL(9,1)));
  memset(pl0,0,3840);
  memset(pl1,0,3840);
  currperso=random(8);
	affiche(x,y,zones[currperso].L,zones[currperso].T);
  
	while(i++)
	{
	 if(i>5000)
	 {
	 	i=1;
	 	currperso=random(8);
	 	memset(pl0,0,3840);
    memset(pl1,0,3840);
    affiche(x,y,zones[currperso].L,zones[currperso].T);
	 }
		if(ROWCOL(0,4))//left
		{
			if(x>10)x-=10;
			memset(pl0,0,3840);
      memset(pl1,0,3840);
			affiche(x,y,zones[currperso].L,zones[currperso].T);
		}
		if(ROWCOL(0,5))//up
		{
			if(y>10)y-=10;
			memset(pl0,0,3840);
      memset(pl1,0,3840);
			affiche(x,y,zones[currperso].L,zones[currperso].T);
		}
		if(ROWCOL(0,6))//right
		{
			if(x<206)x+=10;
			memset(pl0,0,3840);
      memset(pl1,0,3840);
			affiche(x,y,zones[currperso].L,zones[currperso].T);
		}
		if(ROWCOL(0,7))//down
		{
			if(y<80)y+=10;
			memset(pl0,0,3840);
      memset(pl1,0,3840);
			affiche(x,y,zones[currperso].L,zones[currperso].T);
		}
		if(ROWCOL(0,3))//HAND
		{
			if(x>zones[currperso].L-8&&x<zones[currperso].R-8&&y>zones[currperso].T-8&&y<zones[currperso].B-8)
      {
      memset(pl0,0,3840);
      memset(pl1,0,3840);
      draw_fond();
      spr32(zones[currperso].L,zones[currperso].T,24,enemy_sprotch_0,enemy_sprotch_m,pl0);
    	spr32(zones[currperso].L,zones[currperso].T,24,enemy_sprotch_1,enemy_sprotch_m,pl1);
	    draw_marteau_down(x,y);
      virtTOscr();
      while(ROWCOL(0,3));
      i=1;
      bkp=currperso;
	   	while(currperso==bkp)
	  	 currperso=random(8);
	  	 score++;
	  	 }
	  	else
	  	{
	  	memset(pl0,0,3840);
      memset(pl1,0,3840);
	  	draw_fond();
      spr32(zones[currperso].L,zones[currperso].T,24,enemy_0,enemy_m,pl0);
    	spr32(zones[currperso].L,zones[currperso].T,24,enemy_1,enemy_m,pl1);
	    draw_marteau_down(x,y);
      virtTOscr();
      while(ROWCOL(0,3));
	  	}
      affiche(x,y,zones[currperso].L,zones[currperso].T);
		}
		if(ROWCOL(8,6))//esc
		 break;
	}
	memset(pl0,0,3840);
  memset(pl1,0,3840);
  
  sprintf(buffer,"RESULTATS");
  XStr(CENTERED,15,buffer,NORMAL,MODE_OR,pl1);
  XStr(CENTERED,15,buffer,NORMAL,MODE_OR,pl0);
  XStr(CENTERED+1,16,buffer,NORMAL,MODE_OR,pl0);
	if(score>=best_score)
	 {best_score=score;
	  sprintf(buffer,"ALORS LA, BRAVO!!!");
	  XStr(CENTERED,105,buffer,NORMAL,MODE_OR,pl1);
    XStr(CENTERED,105,buffer,NORMAL,MODE_OR,pl0);
    XStr(CENTERED+1,106,buffer,NORMAL,MODE_OR,pl0);
	  }

	if(score<best_score)
	 {sprintf(buffer,"REESSAYE GROS NUL!!!");
	  XStr(CENTERED,105,buffer,NORMAL,MODE_OR,pl1);
    XStr(CENTERED,105,buffer,NORMAL,MODE_OR,pl0);
    XStr(CENTERED+1,106,buffer,NORMAL,MODE_OR,pl0); 
	  }

  sprintf(buffer,"Votre score: %d",score);
  XStr(CENTERED,50,buffer,NORMAL,MODE_OR,pl1);
  XStr(CENTERED,50,buffer,NORMAL,MODE_OR,pl0);
  XStr(CENTERED+1,51,buffer,NORMAL,MODE_OR,pl0);
  sprintf(buffer,"Meilleur score: %d",best_score);
  XStr(CENTERED,70,buffer,NORMAL,MODE_OR,pl1);
  XStr(CENTERED,70,buffer,NORMAL,MODE_OR,pl0);
  XStr(CENTERED+1,71,buffer,NORMAL,MODE_OR,pl0);
  virtTOscr();
	while(!(ROWCOL(6,6)||ROWCOL(9,1)));
  while((ROWCOL(6,6)||ROWCOL(9,1)));
	ENDUSE_TFP();
	GrayOff();
	SetIntVec (AUTO_INT_1, autoint_bkp);//restauration de 'AutoInt 1'
	free(pl0);
	free(pl1);
}
